// Code generated by counterfeiter. DO NOT EDIT.
package blocknotifierfakes

import (
	"sync"

	"github.com/hyperledger/fabric-protos-go/common"
	"github.com/hyperledger/fabric-sdk-go/pkg/client/ledger"
	"github.com/hyperledger/fabric-sdk-go/pkg/common/providers/fab"
	"github.com/kchristidis/island/blocknotifier"
)

type FakeQuerier struct {
	QueryBlockStub        func(uint64, ...ledger.RequestOption) (*common.Block, error)
	queryBlockMutex       sync.RWMutex
	queryBlockArgsForCall []struct {
		arg1 uint64
		arg2 []ledger.RequestOption
	}
	queryBlockReturns struct {
		result1 *common.Block
		result2 error
	}
	queryBlockReturnsOnCall map[int]struct {
		result1 *common.Block
		result2 error
	}
	QueryInfoStub        func(...ledger.RequestOption) (*fab.BlockchainInfoResponse, error)
	queryInfoMutex       sync.RWMutex
	queryInfoArgsForCall []struct {
		arg1 []ledger.RequestOption
	}
	queryInfoReturns struct {
		result1 *fab.BlockchainInfoResponse
		result2 error
	}
	queryInfoReturnsOnCall map[int]struct {
		result1 *fab.BlockchainInfoResponse
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeQuerier) QueryBlock(arg1 uint64, arg2 ...ledger.RequestOption) (*common.Block, error) {
	fake.queryBlockMutex.Lock()
	ret, specificReturn := fake.queryBlockReturnsOnCall[len(fake.queryBlockArgsForCall)]
	fake.queryBlockArgsForCall = append(fake.queryBlockArgsForCall, struct {
		arg1 uint64
		arg2 []ledger.RequestOption
	}{arg1, arg2})
	fake.recordInvocation("QueryBlock", []interface{}{arg1, arg2})
	fake.queryBlockMutex.Unlock()
	if fake.QueryBlockStub != nil {
		return fake.QueryBlockStub(arg1, arg2...)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	fakeReturns := fake.queryBlockReturns
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeQuerier) QueryBlockCallCount() int {
	fake.queryBlockMutex.RLock()
	defer fake.queryBlockMutex.RUnlock()
	return len(fake.queryBlockArgsForCall)
}

func (fake *FakeQuerier) QueryBlockCalls(stub func(uint64, ...ledger.RequestOption) (*common.Block, error)) {
	fake.queryBlockMutex.Lock()
	defer fake.queryBlockMutex.Unlock()
	fake.QueryBlockStub = stub
}

func (fake *FakeQuerier) QueryBlockArgsForCall(i int) (uint64, []ledger.RequestOption) {
	fake.queryBlockMutex.RLock()
	defer fake.queryBlockMutex.RUnlock()
	argsForCall := fake.queryBlockArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeQuerier) QueryBlockReturns(result1 *common.Block, result2 error) {
	fake.queryBlockMutex.Lock()
	defer fake.queryBlockMutex.Unlock()
	fake.QueryBlockStub = nil
	fake.queryBlockReturns = struct {
		result1 *common.Block
		result2 error
	}{result1, result2}
}

func (fake *FakeQuerier) QueryBlockReturnsOnCall(i int, result1 *common.Block, result2 error) {
	fake.queryBlockMutex.Lock()
	defer fake.queryBlockMutex.Unlock()
	fake.QueryBlockStub = nil
	if fake.queryBlockReturnsOnCall == nil {
		fake.queryBlockReturnsOnCall = make(map[int]struct {
			result1 *common.Block
			result2 error
		})
	}
	fake.queryBlockReturnsOnCall[i] = struct {
		result1 *common.Block
		result2 error
	}{result1, result2}
}

func (fake *FakeQuerier) QueryInfo(arg1 ...ledger.RequestOption) (*fab.BlockchainInfoResponse, error) {
	fake.queryInfoMutex.Lock()
	ret, specificReturn := fake.queryInfoReturnsOnCall[len(fake.queryInfoArgsForCall)]
	fake.queryInfoArgsForCall = append(fake.queryInfoArgsForCall, struct {
		arg1 []ledger.RequestOption
	}{arg1})
	fake.recordInvocation("QueryInfo", []interface{}{arg1})
	fake.queryInfoMutex.Unlock()
	if fake.QueryInfoStub != nil {
		return fake.QueryInfoStub(arg1...)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	fakeReturns := fake.queryInfoReturns
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeQuerier) QueryInfoCallCount() int {
	fake.queryInfoMutex.RLock()
	defer fake.queryInfoMutex.RUnlock()
	return len(fake.queryInfoArgsForCall)
}

func (fake *FakeQuerier) QueryInfoCalls(stub func(...ledger.RequestOption) (*fab.BlockchainInfoResponse, error)) {
	fake.queryInfoMutex.Lock()
	defer fake.queryInfoMutex.Unlock()
	fake.QueryInfoStub = stub
}

func (fake *FakeQuerier) QueryInfoArgsForCall(i int) []ledger.RequestOption {
	fake.queryInfoMutex.RLock()
	defer fake.queryInfoMutex.RUnlock()
	argsForCall := fake.queryInfoArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeQuerier) QueryInfoReturns(result1 *fab.BlockchainInfoResponse, result2 error) {
	fake.queryInfoMutex.Lock()
	defer fake.queryInfoMutex.Unlock()
	fake.QueryInfoStub = nil
	fake.queryInfoReturns = struct {
		result1 *fab.BlockchainInfoResponse
		result2 error
	}{result1, result2}
}

func (fake *FakeQuerier) QueryInfoReturnsOnCall(i int, result1 *fab.BlockchainInfoResponse, result2 error) {
	fake.queryInfoMutex.Lock()
	defer fake.queryInfoMutex.Unlock()
	fake.QueryInfoStub = nil
	if fake.queryInfoReturnsOnCall == nil {
		fake.queryInfoReturnsOnCall = make(map[int]struct {
			result1 *fab.BlockchainInfoResponse
			result2 error
		})
	}
	fake.queryInfoReturnsOnCall[i] = struct {
		result1 *fab.BlockchainInfoResponse
		result2 error
	}{result1, result2}
}

func (fake *FakeQuerier) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.queryBlockMutex.RLock()
	defer fake.queryBlockMutex.RUnlock()
	fake.queryInfoMutex.RLock()
	defer fake.queryInfoMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeQuerier) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ blocknotifier.Querier = new(FakeQuerier)
